# Test Data Generator using Hinnant Date Library

The `generate_data.cpp` program generates the `validation_data.json` file
needed by:

    * `tests/validation/BasicHinnantDateTest/`
    * `tests/validation/ExtendedHinnantDateTest/`

The program reads the `zones.txt` file (generated by the `tzcompiler.py`
program) which contains the list of zones supported by zoneinfo files in
`src/ace_time/zonedb/` and `src/ace_time/zonedbx`. The program then generates a
test data set of all DST transitions, the epoch seconds, and the expected
date/time components using the [Hinnant
Date](https://github.com/HowardHinnant/date) C++11/14/17 library.

## Compiling

I have tested this Ubuntu 18.04 and 20.04. Install the following:

* CMake
    * `$ sudo apt install cmake`
* libcurl library
    * `$ sudo apt install libcurl4-openssl-dev`
* [Hinnant Date](https://github.com/HowardHinnant/date) library as a
    **sibling** to AceTime
    * `$ cd $ACE_TIME_DIR/..`
    * `$ git clone https://github.com/HowardHinnant/date`
    * This repo does not seem to have any release process or version number.
      Occasionally, the repo may need to be updated manually with a `$ git
      pull`.

Then type make to generate `generate_data.out`:
```
$ make
```
